unit UClassSeguranca;

interface

uses Classes, dbTables, stdctrls, Grids, Sysutils,
     Db, DBClient;


type

TSeguranca = Class(tpersistent)
   protected

   private
    Fle_usuario   : String;
    Fle_tag       : Integer;
    Fle_alteracao : Integer;
    Fle_acesso    : Integer;
    Fle_exclusao  : Integer;
    Fle_inclusao  : Integer;
    Fle_relatorio : Integer;
    FDataSource: TDataSource;

    procedure Setle_usuario   (const Value: String);
    procedure Setle_tag       (const Value: Integer);
    procedure Setle_acesso    (const Value: Integer);
    procedure Setle_alteracao (const Value: Integer);
    procedure Setle_exclusao  (const Value: Integer);
    procedure Setle_inclusao  (const Value: Integer);
    procedure Setle_relatorio (const Value: Integer);
    procedure SetDataSource(const Value: TDataSource);
    procedure Leitura(q : TClientDataSet);

   public
     property le_usuario   : String read Fle_usuario    write Setle_usuario;
     property le_tag       : Integer read Fle_tag       write Setle_tag;
     property le_acesso    : Integer read Fle_acesso    write Setle_acesso;
     property le_inclusao  : Integer read Fle_inclusao  write Setle_inclusao;
     property le_alteracao : Integer read Fle_alteracao write Setle_alteracao;
     property le_exclusao  : Integer read Fle_exclusao  write Setle_exclusao;
     property le_relatorio : Integer read Fle_relatorio write Setle_relatorio;

     property DataSource : TDataSource read FDataSource write SetDataSource;

     function  GetSegurancaList(musuario : String) : TList;
     procedure Salvar(mdata : Pointer);

     Class function Pesquisa(mlist : TList; musuario: String; mtag: Integer): TSeguranca;
End;

implementation

{ TSeguranca }


function TSeguranca.GetSegurancaList (musuario : String): TList;
// pego todas as permissoes do usuario
var
  List   : TList;
  New    : TSeguranca;
  i      : Integer;
  q      : TClientDataSet;
begin
  List   := Nil;
  Result := Nil;
  try
     List   := TList.Create;
     try
       q := TClientDataSet(DataSource.DataSet);

       With q Do
       Begin
          Close;
          Params[0].Value := musuario;
          Open;
          Prior;

          while not Eof do
          begin
            New := TSeguranca.Create;
            New.Leitura(q);
            List.Add(Pointer(New));
            next;
          end;
          Close;
       End;
       Result   := List;
     finally
     end;
  except
     for i:=0 to List.Count-1 do
        TObject(List[i]).Free;

     List.Free;
     raise;
  end;
end;

procedure TSeguranca.Leitura(q : TClientDataSet);
begin
    Fle_usuario   := q.FieldByName('USUARIO').AsString;
    Fle_tag       := q.FieldByName('TAG').AsInteger;
    Fle_acesso    := q.FieldByName('ACESSO').AsInteger;
    Fle_inclusao  := q.FieldByName('INCLUSAO').AsInteger;
    Fle_alteracao := q.FieldByName('ALTERACAO').AsInteger;
    Fle_exclusao  := q.FieldByName('EXCLUSAO').AsInteger;
    Fle_relatorio := q.FieldByName('RELATORIO').AsInteger;
end;

class function TSeguranca.Pesquisa(mlist : TList; musuario: String; mtag: Integer): TSeguranca;
var
  q       : TClientDataSet;
  New     : TSeguranca;
  i, mtot : Integer;
begin
   New := nil;
   New := TSeguranca.Create;

   New.Fle_usuario   := musuario;
   New.Fle_tag       := mtag;
   New.Fle_acesso    := 0;
   New.Fle_inclusao  := 0;
   New.Fle_alteracao := 0;
   New.Fle_exclusao  := 0;
   New.Fle_RELATORIO := 0;

   mtot := mlist.Count -1;

   If mtot > 0 Then
   Begin
      i    := 0;
      While (i <= mtot) Do
      Begin
         If TSeguranca(mlist[i]).le_tag = mtag Then
         Begin
            New.le_usuario   := musuario;
            New.le_tag       := mtag;
            New.le_acesso    := TSeguranca(mlist[i]).le_acesso;
            New.le_inclusao  := TSeguranca(mlist[i]).le_inclusao;
            New.le_alteracao := TSeguranca(mlist[i]).le_alteracao;
            New.le_exclusao  := TSeguranca(mlist[i]).le_exclusao;
            New.le_relatorio := TSeguranca(mlist[i]).le_relatorio;
            Break;
         End
         Else if TSeguranca(mlist[i]).le_tag > mtag Then
            Break;

         Inc(i);
      End;
   End;

   Result := New;
end;

procedure TSeguranca.Setle_acesso(const Value: Integer);
begin
  Fle_acesso := Value;
end;

procedure TSeguranca.Setle_alteracao(const Value: Integer);
begin
  Fle_alteracao := Value;
end;

procedure TSeguranca.Setle_exclusao(const Value: Integer);
begin
  Fle_exclusao := Value;
end;

procedure TSeguranca.Setle_inclusao(const Value: Integer);
begin
  Fle_inclusao := Value;
end;

procedure TSeguranca.Setle_tag(const Value: Integer);
begin
  Fle_tag := Value;
end;

procedure TSeguranca.Setle_usuario(const Value: String);
begin
  Fle_usuario := Value;
end;

procedure TSeguranca.Setle_relatorio(const Value: Integer);
begin
  Fle_relatorio := Value;
end;

procedure TSeguranca.Salvar(mdata: Pointer);
var
  q  : TClientDataSet;
  i        : Integer;
  machou   : Boolean;
begin
   try
     q := TClientDataSet(DataSource.DataSet);
     With q Do
     Begin
       Close;
       Params[0].Value := TSeguranca(mdata).le_usuario;
       Open;
       machou := Locate('TAG',TSeguranca(mdata).le_tag,[loCaseInsensitive]);
     End;

     With q Do
     Begin
        If (machou) and (TSeguranca(mdata).le_acesso = 0) Then
        Begin
           // apaga
           Delete;
           ApplyUpdates(0);
        End
        Else If machou and (TSeguranca(mdata).le_acesso = 1) Then
        Begin
           // edita
           Edit;
           FieldByName('TAG').AsInteger       := TSeguranca(mdata).le_tag;
           FieldByName('USUARIO').AsString    := TSeguranca(mdata).le_usuario;
           FieldByName('ACESSO').AsInteger    := TSeguranca(mdata).le_acesso;
           FieldByName('INCLUSAO').AsInteger  := TSeguranca(mdata).le_inclusao ;
           FieldByName('ALTERACAO').AsInteger := TSeguranca(mdata).le_alteracao;
           FieldByName('EXCLUSAO').AsInteger  := TSeguranca(mdata).le_exclusao ;
           FieldByName('RELATORIO').AsInteger := TSeguranca(mdata).le_relatorio;
           ApplyUpdates(0);
        End
        Else If not machou and (TSeguranca(mdata).le_acesso = 1) Then
        Begin
           // inclusao
           Insert;
           FieldByName('TAG').AsInteger       := TSeguranca(mdata).le_tag;
           FieldByName('USUARIO').AsString    := TSeguranca(mdata).le_usuario;
           FieldByName('ACESSO').AsInteger    := TSeguranca(mdata).le_acesso   ;
           FieldByName('INCLUSAO').AsInteger  := TSeguranca(mdata).le_inclusao ;
           FieldByName('ALTERACAO').AsInteger := TSeguranca(mdata).le_alteracao;
           FieldByName('EXCLUSAO').AsInteger  := TSeguranca(mdata).le_exclusao ;
           FieldByName('RELATORIO').AsInteger := TSeguranca(mdata).le_relatorio;
           ApplyUpdates(0);
        End;
     End;
   finally
   //  q.Free;
   end;
end;

procedure TSeguranca.SetDataSource(const Value: TDataSource);
begin
  FDataSource := Value;
end;

end.
